; $Id: fans_resize.pro,v 1.1 2002/11/07 21:54:13 azuah Exp $
;===============================================================================
; Event handler function for FANS_DATREDUC program defined in fans_datreduc.pro.
;
; * handle resizing events for tlb
;
; Richard Tumanjong Azuah
;
; Nov 2002 - Initial writing
;

pro fans_resize, event

widget_control, event.top, get_uvalue=sPtr

; new plot window width is maximum of the two r-values
(*sPtr).winWidth = (event.x - (*sPtr).restOfWidth) > (*sPtr).minXSize

; new plot window height is maximum of two r-values
(*sPtr).winHeight = (event.y - (*sPtr).restOfHeight) > (*sPtr).minYSize


; Delete and recreate pixmap window using new dimensions
wdelete, (*sPtr).winPix
window,/free,/pixmap,xsize=(*sPtr).winWidth,ysize=(*sPtr).winHeight
(*sPtr).winPix = !d.window
; Also resize visible window using new dimensions 
widget_control, (*sPtr).winVisID, xsize=(*sPtr).winWidth, ysize=(*sPtr).winHeight

widget_control, (*sPtr).tlbID, /realize

; Finally, update the display
widget_control, (*sPtr).sViewID, get_uvalue=sViewOn
widget_control, (*sPtr).bViewID, get_uvalue=bViewOn
widget_control, (*sPtr).fViewID, get_uvalue=fViewOn
widget_control, (*sPtr).oViewID, get_uvalue=oViewOn
case 1 of
    sViewOn: begin
        if ((*sPtr).sampCount lt 1) then return
        index = (*sPtr).sampIndex
        dataPtr = (*(*sPtr).sDataPtr)[index]
        updatePlotSlider, sPtr,'samp',dataPtr,err=err,emsg=emsg
    end

    bViewOn: begin
        if ((*sPtr).bkgdCount lt 1)  then return
        index = (*sPtr).bkgdIndex
        dataPtr = (*(*sPtr).bDataPtr)[index]
        updatePlotSlider, sPtr,'bkgd',dataPtr,err=err,emsg=emsg
    end

    fViewOn: begin
        if ((*sPtr).fastCount lt 1)  then return
        fans_plotData, sPtr,'fast',err=err,emsg=emsg ; can't view det cuts
    end 

    oViewOn: begin
        if ((*sPtr).sampCount lt 1)  then return
        fans_outpCalc, sPtr, err=err, emsg=emsg
        if (err ne 0) then begin
            printerror,err,emsg
            return
        endif
        fans_plotData, sPtr,'outp',err=err,emsg=emsg ; can't view det cuts
    end 

endcase

;print,'resize ____________________________________'
;print,'event.x = ',event.x,';   event.y = ',event.y
;tlbInfo = widget_info((*sPtR).tlbID,/geometry)
;print,'tlbInfo.x = ',tlbInfo.scr_xsize,'   tlbInfo.y = ',tlbInfo.scr_ysize
;print,'tlbInfo.xpad = ',tlbInfo.xpad,'   tlbInfo.ypad = ',tlbInfo.ypad
;print,'minxSize = ',(*sPtr).minXSize,'   minySize = ',(*sPtr).minYSize
;print,'xSize = ',(*sPtr).winWidth,'   ySize = ',(*sPtr).winHeight
;print,'winVisID = ',(*sPtr).winVisID,'    winPix = ',(*sPtr).winPix
;print,'____________________________________'




end
