; $Id: dave_disptreat.pro,v 1.2 2002/06/21 20:15:47 dimeo Exp $
;===============================================================================
; NAME:
;  DAVE_DISPTREAT:
; PURPOSE
;  Widget procedure that displays the contents of the data treatment pointer
;  if there are any.
; SYNTAX:
;  Put the call to this procedure in your widget definition module as shown
;  below.
;
;  button = widget_button(filemenu,value = 'Display Data Information',$
;								event_pro = 'dave_disptreat')
; INPUTS:
;   NONE....it assumes that the treatmentptr field is filled (otherwise it
;   gives you an error message) and it pulls it out and displays it.
;
; KEYWORDS:
;   NONE
;
; USES:
;   DISP_TREAT.PRO
;----------------
; R.M.Dimeo
; NCNR, NIST
; June 21 2002
;
;;;;;;;;;;;;
pro dave_disptreat,event
; Display file header info and the contents of the treatment
widget_control,event.top,get_uvalue = pState,/no_copy
if n_elements(*(*(*pState).dataStrPtr).commonStr.treatmentPtr) eq 0 then begin
  text = 'No data has been loaded'
  void = dialog_message(dialog_parent = event.top,text)
  widget_control,event.top,set_uvalue = pState,/no_copy
  return
endif
text = [*(*(*pState).dataStrPtr).commonStr.treatmentPtr]
void = disp_treat(group_leader = event.top,text)
widget_control,event.top,set_uvalue = pState,/no_copy
return
end