;$Id: Ive.pro,v 1.1 2002/04/23 14:47:01 jmspark Exp $
pro ive $
	, q, e, ri, dri $
	, eo, rio, drio $
	, qran=qran, white=white, q2=q2

; if keyword q2 is selected, it calculates int of ri*q^2 dq/int of q^2 dq
if n_elements(qran) ne 2 then qran=[min(q),max(q)]
if n_elements(white) ne 1 then white=-1e30

; Save the original values.
q0	=	q
e0	=	e
ri0	=	ri
dri0 = dri

void = array_oned2twod( q0, e0, q, e )

; if sq[0] eq 1 then begin
;	nw	=	n_elements(e)
;	oned	=	1.+fltarr(nw)
;	q	=	q#oned
; endif

;ws	=	size(e)
;if ws[0] eq 1 then begin
;	oned	=	1.+fltarr(n_elements(q[*,0]))
;	e	=	oned#e
; endif

; Prepare the output vectors.
nes	=	n_elements(e[0,*])
eo	=	fltarr(nes)
d_y = n_elements( ri[0, * ] )
rio = fltarr( d_y )
drio = rio

num	=	fltarr( d_y )
inum	=	-1

for i=0, d_y - 1 do begin

	lisq = ( d_y eq nes ) $
		? ( where(q(*,i) ge qran(0) and q(*,i) le qran(1)	and ri(*,i) ne white,nlisq ) ) $
		: ( where(q[*,i] ge qran[0] and q[*,i] le qran[1] $
			and q[*,i+1] ge qran[0] and q[*,i+1] le qran[1] $
			and ri[*,i] ne white $
			, nlisq ) $
		  )

	if nlisq gt 0 then begin
		inum	=	inum+1
		num(inum)	=	i
		eo(i)	=	(d_y eq nes ) $
			? total(e(lisq,i))/nlisq $
			: total( e[lisq, i] + e[lisq, i+1] ) / 2d / nlisq

		if keyword_set(q2) then begin
			qden	=	0
			for j=0,nlisq-2 do begin
			qden	=	qden+q(lisq(j),i)^2*abs(q(lisq(j),i)-q(lisq(j+1),i))
			rio(i)	=	rio(i)+ri(lisq(j),i)*q(lisq(j),i)^2	$
					 * abs(q(lisq(j),i)-q(lisq(j+1),i))
			drio(i)	=	drio(i)^2+dri(lisq(j),i)^2*q(lisq(j),i)^4	$
					 * abs(q(lisq(j),i)-q(lisq(j+1),i))^2
			endfor
			rio(i)	=	rio(i)/qden
			drio(i)	=	sqrt(drio(i))/qden
		endif else begin
			rio[i] = total( ri[lisq,i] ) / nlisq
			drio(i)	=	sqrt(total(dri(lisq,i)^2))/nlisq
		endelse
	endif
end

num	=	num(0:inum)
eo	=	eo(num)
rio	=	rio(num)
drio	=	drio(num)

; Restore the original arrays.
q	=	q0
e	=	e0
ri	=	ri0
dri	=	dri0

end

